//var stdout = '';
//var stderr = '';
//var tee = true;

function capture_stdio(callbackout, callbackerr, tee) {
    if (!tee) tee = false;
    var old_out = process.stdout.write;
    var old_err = process.stderr.write;

    process.stdout.write = (function(write) {
        return function(string, encoding, fd) {
            if (tee) write.apply(process.stdout, arguments);
            callbackout(string, encoding, fd);
        };
    })(process.stdout.write);

    process.stderr.write = (function(write) {
        return function(string, encoding, fd) {
            if (tee) write.apply(process.stderr, arguments);
            callbackerr(string, encoding, fd);
        };
    })(process.stderr.write);

    return function() {
        process.stdout.write = old_out;
        process.stderr.write = old_err;
    };
}

//console.log("run...");

//var release_stdio = capture_stdio(function(string, encoding, fd) {
        //stdout += string;
    //}, function(string, encoding, fd) {
        //stderr += string;
    //});

//console.log('c');
//console.log('d');

//release_stdio();

//console.log("all is done");

//console.log(stdout);
//console.log(stderr);

module.exports = capture_stdio;
